{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}

{% block css %}
    <link rel="stylesheet" type="text/css" href="{% static 'profile/css/datatables/datatables.min.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'profile/css/datatables/datatables-responsive.css' %}">
{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}

    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Pengguna</li>
        </ol>
    </nav>

    <a href="{% url 'profile:admin_user_create' %}"> 
        <button type="button" class="btn btn-info mt-2 mb-4"><i class="bi bi-plus"></i> Tambah Pengguna</button>
    </a>
    

    <div class="card shadow mb-5">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h6 class="m-0 font-weight-bold text-info">Pengguna</h6>
            <div class="dropdown no-arrow">
                <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                </a>
            </div>
        </div>
        <div class="card-body">
            <div class="table-responsive py-3">
                <table class="table table-striped table-bordered dt-responsive nowrap" width="100%" id="table-list">
                    <thead class="bg-info text-white">
                        <tr>
                            <th scope="col" class="text-center">#</th>
                            <th scope="col" class="text-center">Username</th>
                            <th scope="col" class="text-center">Nama</th>
                            <th scope="col" class="text-center">Email</th>
                            <th scope="col" class="text-center">Telepon</th>
                            <th scope="col" class="text-center">Role</th>
                            <th scope="col" class="text-center">Dibuat</th>
                            <th scope="col" class="text-center">Status</th>
                            <th scope="col" class="text-center">Aksi</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for user in users %}
                            <tr>
                                <th>{{ forloop.counter }}</th>
                                <td>{{ user.username }}</td>
                                <td>{{ user.first_name }} {{ user.last_name }}</td>
                                <td>{{ user.email }}</td>
                                <td>{{ user.phone }}</td>
                                <td>{{ user.role }}</td>
                                <td>{{ user.date_joined }}</td>
                                <td class="text-center">
                                    {% if user.is_active %}
                                        <a href="{% url 'profile:non_aktif' user.id %}" title="Non Aktif" class="btn btn-md bg-success btn-icon text-white" type="button">
                                            {% if user.is_active %}Aktif{% else %}Tidak Aktif{% endif %}
                                        </a>
                                    {% else %}
                                        <a href="{% url 'profile:aktif' user.id %}" title="Re Aktif" class="btn btn-md bg-danger btn-icon text-white" type="button">
                                            {% if user.is_active %}Aktif{% else %}Tidak Aktif{% endif %}
                                        </a>
                                    {% endif %}
                                </td>
                                <td class="text-center">
                                    <button href="#" class="btn btn-info btn-circle pass-data" 
                                        data-tooltip="tooltip" data-placement="top" title="Detail"
                                        data-toggle="modal" data-target="#modal-center"
                                        data-username="{{ user.username }}"
                                        data-avatar="{% if user.avatar %} {{ user.avatar.url }} {% else %} {% static 'profile/images/profile.png' %} {% endif %}"
                                        data-nama="{{ user.first_name }} {{ user.last_name }}"
                                        data-email="{{ user.email }}"
                                        data-tanggal_lahir="{{ user.date_of_birth }}"
                                        data-role="{{ user.role}}"
                                        data-telepon="{{ user.phone }}">
                                        <i class="bi bi-info"></i>
                                    </button>
                                    <button href="#" class="btn btn-info btn-circle pass-data-ubah" 
                                        data-tooltip="tooltip" data-placement="top" title="Ubah Role"
                                        data-toggle="modal" data-target="#modal-ubah"
                                        data-id="{{ user.id }}"
                                        data-username="{{ user.username }}"
                                        data-foto="{% if user.avatar %} {{ user.avatar.url }} {% else %} {% static 'profile/images/profile.png' %} {% endif %}"
                                        data-email="{{ user.email }}"
                                        data-first="{{ user.first_name }}"
                                        data-last="{{ user.last_name }}"
                                        data-role="{{ user.role }}"
                                        data-phone="{{ user.phone }}"
                                        data-birth="{{ user.date_of_birth }}">
                                        <i class="bi bi-pencil"></i>
                                    </button>

                                    <!-- {% if user.is_active %}
                                        <button href="#" class="btn btn-danger btn-circle" 
                                            onclick="delete_('soft_delete', `{{ user.first_name }} {{ user.last_name }}`, '{{ user.username }}', 'user', 'Pengguna')"
                                            data-toggle="tooltip" data-placement="top" title="Nonaktifkan">
                                            <i class="bi bi-archive"></i>
                                        </button>
                                    {% else %}
                                        <button class="btn btn-success btn-circle" 
                                            onclick="restore_(`{{ user.first_name }} {{ user.last_name }}`, '{{ user.username }}', 'user', 'Pengguna')"
                                            data-toggle="tooltip" data-placement="top" title="Memulihkan">
                                            <i class="bi bi-arrow-counterclockwise"></i>
                                        </button>
                                    {% endif %} -->
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    
    <div class="modal fade" id="modal-center" tabindex="-1" role="dialog" aria-labelledby="modal-centerTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                <h5 class="m-0 font-weight-bold text-info" id="exampleModalLongTitle">Detail User</h5>
                <button type="button" class="close text-info" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                </div>
                <div class="modal-body">
                        <div class="text-center">
                            <img id="avatarnya"  class="img-fluid rounded-circle" src="" alt="" width="200" height="100">
                        </div>
                        <div class="form-group">
                            <label for="detail-nama">Nama</label>
                            <input type="text" class="form-control" id="detail-nama" disabled>
                        </div>
                        <div class="form-group">
                            <label for="detail-tanggal_lahir">Tanggal Lahir</label>
                            <input type="text" class="form-control" id="detail-tanggal_lahir" disabled>
                        </div>
                        <div class="form-group">
                            <label for="detail-role">Role</label>
                            <input type="text" class="form-control" id="detail-role" disabled>
                        </div>
                        <div class="form-group">
                            <label for="detail-telepon">Telepon</label>
                            <input type="text" class="form-control" id="detail-telepon" disabled>
                        </div>
                        <div class="form-group">
                            <label for="detail-email">Email</label>
                            <input type="text" class="form-control" id="detail-email" disabled>
                        </div>
                </div>
                <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <!-- <button type="button" class="btn btn-info">Save changes</button> -->
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modal-ubah" tabindex="-1" role="dialog" aria-labelledby="modal-centerTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="m-0 font-weight-bold text-info" id="exampleModalLongTitle">Ubah Role User</h5>
                    <button type="button" class="close text-info" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form onsubmit="return validateFile()" enctype="multipart/form-data" action="{% url 'profile:admin_user_edit_role' %}" method="POST">
                        {% csrf_token %}
                        <input type="hidden" name="id" id="detail-id">
                        {% if request.user.avatar %}
                            <div class="text-center">
                                <img id="detail-foto"  class="img-fluid rounded-circle" src="" alt="" width="200" height="100">
                                <br>
                                <small>File lama kosongi apabila tidak ingin mengganti file</small>
                            </div>
                        {% endif %}
                        <div class="form group">
                            <label for="avatar">Avatar</label>
                            <input type="file" class="form-control" name="foto" accept="image/png, image/jpeg, image/webp">
                        </div>
                        <script>
                            function validateFile() {
                              var fileInput = document.getElementById('foto');
                              var filePath = fileInput.value;
                              var allowedExtensions = /(\.png|\.jpeg|\.webp)$/i;
                  
                              if (filePath === '') {
                                  // alert('Mohon pilih file thumbnail berita.');
                                  return true;
                              }
                  
                              if (!allowedExtensions.exec(filePath)) {
                                  alert('Tipe file tidak diizinkan. Harap pilih file dengan ekstensi PNG, JPEG, atau WebP.');
                                  fileInput.value = '';
                                  return false;
                              }
                              return true;
                          }
                        </script>

                        <div class="form-group">
                            <label for="email">Email</label>
                            <input type="email" placeholder="Masukkan Email..."
                                class="form-control"
                                name="email"
                                id="email">
                        </div>

                        <div class="form-group">
                            <label for="first_name">First Name</label>
                            <input type="text" placeholder="Masukkan First Name..."
                                class="form-control"
                                name="first"
                                id="first">
                        </div>

                        <div class="form-group">
                            <label for="last_name">Last Name</label>
                            <input type="text" placeholder="Masukkan last Name..."
                                class="form-control"
                                name="last"
                                id="last">
                        </div>

                        <div class="form-group">
                            <label for="phone">Nomor Handphone</label>
                            <input type="number" placeholder="Masukkan Nomor Handphone..."
                                class="form-control"
                                name="phone"
                                id="phone">
                        </div>

                        <!-- <div class="form-group">
                            <label for="birth">Tanggal Lahir</label>
                            <input type="date" placeholder="Masukkan Tanggal Lahir..."
                                class="form-control"
                                name="birth"
                                id="detail-tanggal_lahir">
                        </div> -->

                        <div class="form-group">
                            <input type="hidden" name="username" id="ubah-username">
                            <label for="role">Hak Akses</label>
                            <select class="form-control" id="role" name="role">
                                <option value="admin">Admin</option>
                                <option value="posting">Posting</option>
                            </select> 
                        </div>  
                        <button type="submit" class="btn btn-success"><i class="bi bi-save"></i> Simpan</button>
                    </form>              
                </div>
            </div>
        </div>
    </div>
{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
    <script src="{% static 'profile/js/datatables/datatables.min.js' %}"></script>
    <script src="{% static 'profile/js/admin/admin-aksi.js' %}"></script>
    <script>
        $(document).ready( function () {
            $('[data-tooltip="tooltip"]').tooltip();
            $('#table-list').DataTable({
                responsive: true,
            });
            $('#table-archive').DataTable({
                responsive: true,
            });
        });
        $('.pass-data').click(function(){
            $('#detail-username').val($(this).attr('data-username'));
            $('#detail-nama').val($(this).attr('data-nama'));
            $('#detail-email').val($(this).attr('data-email'));
            $('#detail-tanggal_lahir').val($(this).attr('data-tanggal_lahir'));
            $('#detail-bio').val($(this).attr('data-bio'));
            $('#detail-role').val($(this).attr('data-role'));
            $('#detail-telepon').val($(this).attr('data-telepon'));
            $('#avatarnya').attr('src', $(this).attr('data-avatar'));
        });
        $('.pass-data-ubah').click(function(){
            $('#ubah-username').val($(this).attr('data-username'));
            $('#detail-foto').attr('src', $(this).attr('data-foto'));
            $('#email').val($(this).attr('data-email'));
            $('#first').val($(this).attr('data-first'));
            $('#last').val($(this).attr('data-last'));
            $('#role').val($(this).attr('data-role'));
            $('#phone').val($(this).attr('data-phone'));
            $('#detail-id').val($(this).attr('data-id'));
        //     var birthData = $(this).attr('data-birth');
        //     var birthDate = new Date(birthData); // Ubah string menjadi objek Date
        //     var formattedDate = formatDate(birthDate); // Panggil fungsi formatDate untuk memformat tanggal lahir

        //     $('#detail-tanggal_lahir').val(formattedDate);
        });

        // function formatDate(date) {
        //     var day = String(date.getDate()).padStart(2, '0');
        //     var month = String(date.getMonth() + 1).padStart(2, '0');
        //     var year = date.getFullYear();

        //     // Format tanggal sebagai "YYYY-MM-DD"
        //     var formattedDate = year + '-' + month + '-' + day;

        //     return formattedDate;
        // }
    </script>
{% endblock scripts_bawah %}